Require Import connectives.
Require Import leibniz.
Require Import nat.
Parameter invert_permut : nat.nat -> (nat.nat -> nat.nat) -> nat.nat -> nat.nat.
Parameter invert_permut_body : nat.nat -> (nat.nat -> nat.nat) -> nat.nat -> nat.nat.
Axiom axiom_invert_permut : forall (n:nat.nat), connectives.equal ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut n) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n).
Definition eq_invert_permut : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut n) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n) := fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut n)) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n)) ((axiom_invert_permut) (n)).
Definition sym_eq_invert_permut : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n) (invert_permut n) := fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut n)) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n)) ((eq_invert_permut) (n)).
